% this function plots the dimer triangles and colours them according to
% their activity.
% the inpt vector is a vector with 20 entrie corresponding to the
% triangles. A value of 0 represents a relaxed triangle (not 
% phosphorylated and no collapsed neighbour), 1 designates a collapsed 
% triangle, and 2 stands for a triangle whose neighbour is collapsed.
% 

function PlotTriaSurf_1107(tsta,name)

msta = mean(tsta,2);
% mean state condition over simulation time

[cols,rows] = find(tsta==1);
tcnt = hist(sort(cols),1:20);

mclp = tcnt-min(tcnt)+1;
cmap = colormap(jet(max(mclp)));

% sols = unique(msta);
% nsol = length(sols);
% cols = 1;
% for i1 = 1:nsol
%     [indx,b]=find(msta==sols(i1));
%     ccod(indx)=cols;
%     cols=cols+1;
% end
% number of different solutions, determines the number of colours to be
% taken
% cmap = colormap(jet(nsol));

llen = 2;
xu=[0;llen;1;0];
yu=[0;0;1;0];
xo=[1;3;2;1];
yo=[4;4;3;4];
xs=[.5,1.5,1,.5];
ys=[2,2,1,2];
xt=[1.5,2.5,2,1.5];
yt=[2,2,3,2];

figure; 
hold on
for i1 = 1:20
    if i1 < 6
        area(xu,yu,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xu=xu+llen;
    elseif i1 < 11 && i1 > 5
        area(xs,ys,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xs=xs+llen;
    elseif i1 < 16 && i1 > 10
        area(xt,yt,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xt=xt+llen;
    else
        area(xo,yo,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xo=xo+llen;
     end
end
cb = colorbar('vert');
zlab = get(cb,'ylabel');
set(zlab,'String','triangle state','fontsize',26); 
caxis([min(tcnt)/size(tsta,2),max(tcnt)/size(tsta,2)])
axis tight
axis off

if ~exist('name','var')
   name = []; 
end
if ~isempty(name)
    print('-dpng',name)
end
