% generating a video of triangle simulations
% input matrix with columns of different times and rows with state
% representations of each of the 20 triangle positions. States are [0,1,2]
% in which 0 is the relaxed state, 1 is the collapsed state and 2 is the
% inhibited state.
% strin is active if during the simulation a stress input was applied, and
% strin contains the step of stress activation

function VideoTriangle_1107(tsta,strin)
figure
cmap = [0,0,1;1,0,0];%colormap(jet(2));

for i1 = 1:size(tsta,2)
    clf;hold on;    
    line([0,0],[4.5,5],'color','k')
	line([11,11],[4.5,5],'color','k')
	line([0,11/size(tsta,2)*i1],[4.75,4.75],'linewidth',20)
    [ind1,b] = find(tsta(:,i1)==1);
    colc=ones(20,1);
    colc(ind1)=2;
    if exist('strin','var')
        stbg = 11/size(tsta,2)*strin;
        line([stbg,stbg],[4.5,5],'color','r')
    end

    llen = 2;
    xu=[0;llen;1;0];
    yu=[0;0;1;0];
    xo=[1;3;2;1];
    yo=[4;4;3;4];
    xs=[.5,1.5,1,.5];
    ys=[2,2,1,2];
    xt=[1.5,2.5,2,1.5];
    yt=[2,2,3,2];
    
    for i2 = 1:20
    if i2 < 6
        area(xu,yu,'facecolor',cmap(colc(i2),:),'linestyle','none')
        xu=xu+llen;
    elseif i2 < 11 && i2 > 5
        area(xs,ys,'facecolor',cmap(colc(i2),:),'linestyle','none')
        xs=xs+llen;
    elseif i2 < 16 && i2 > 10
        area(xt,yt,'facecolor',cmap(colc(i2),:),'linestyle','none')
        xt=xt+llen;
    else
        area(xo,yo,'facecolor',cmap(colc(i2),:),'linestyle','none')
        xo=xo+llen;
    end
    end
    
    axis tight
    axis off
    surf_movi(i1) = getframe(gcf);
end
movie2avi(surf_movi,['surf_avi_triangle_1205'],'fps',5)

