% this function plots the dimer triangles and colours them according to
% their activity.
% the inpt vector is a vector with 20 entries corresponding to the
% triangles. A value of 2 designates a collapsed triangle, and is coloured
% accordingly.

function plot_hextri_dyn(inpt,name)


% if there are more than one time steps the frequency in which a triangle
% is activated is color coded. For this we determine the maximum number of
% activation for any triangle.
[cols,rows] = find(inpt==2);
tcnt = hist(sort(cols),1:20);

mclp = tcnt-min(tcnt)+1;
cmap = colormap(jet(max(mclp)));

%rshd = linspace(0.01,1,mclp);

%[s,d,tcol] = unique(mclp);

%cmap = [0,0,1];
%for i1 = 1:mclp
%    cmap(i1+1,:)=[rshd(i1),0,0];
%end

llen = 2;
xu=[0;llen;1;0];
yu=[0;0;1;0];
xo=[1;3;2;1];
yo=[4;4;3;4];
xs=[.5,1.5,1,.5];
ys=[2,2,1,2];
xt=[1.5,2.5,2,1.5];
yt=[2,2,3,2];

%figure; 
hold on
for i1 = 1:20
    if i1 < 6
        area(xu,yu,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xu=xu+llen;
    elseif i1 < 11 && i1 > 5
        area(xs,ys,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xs=xs+llen;
    elseif i1 < 16 && i1 > 10
        area(xt,yt,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xt=xt+llen;
    else
        area(xo,yo,'facecolor',cmap(mclp(i1),:),'linestyle','none')
        xo=xo+llen;
     end
end

axis tight


if ~exist('name','var')
   name = []; 
end
if ~isempty(name)
    print('-dpng',name)
end
