%% analyse triangle simulation
% input colm
% 1st analysis of activation over time
clear

set(0,'defaultaxesfontsize',30)
set(0,'defaulttextfontsize',30)

% performing 20 simulations of the stressosome for crude statistics
ppar=[.001,.25,.01];
step=600;
msac=zeros(20,step);
strin=[400,.5];
colm=trianglestressosome_1107(ppar,step,strin);
msac = mean(colm);
figure
plot(msac,'-ok')
% xlabel('time','fontsize',23)
% ylabel('collapse fraction','fontsize',23)
a=axis;
line([400,400],[a(3),a(4)],'color','k','linestyle','--')
set(findobj(gcf,'Type','line'),'LineWidth',3)

% print('-dpng',['/users/sbi00/uliebal/Documents/yang/rostock/sysmo1_bacell/models/struct_stress/p1012/triangle_sim/data/1205_time-VS-collfract_+-stress1run'])
PlotTriaSurf_1107(colm)
% VideoTriangle_1107(colm,strin(1))

%%
set(0,'defaultaxesfontsize',23)
set(0,'defaulttextfontsize',23)

% performing 20 simulations of the stressosome for crude statistics
% stat = 3;
% rept = [10,20,30,50,100,200];
% relv = zeros(stat,length(rept));
% for i00 = 1:stat
% for i0 = 1:length(rept)
ppar=[.001,.25,.01];
strin = [400,.5];
step=600;
nstr=50;
msac=zeros(20,step);
for i1=1:nstr
    colm=trianglestressosome_1107(ppar,step,strin);
    msac(i1,:)=mean(colm);
end
mstr = mean(msac);
vstr = std(msac);
%relv(i00,i0) = mean(vstr)/mean(mstr);
% end
% end
figure; hold on
plot(1:step,mstr,'ok')
plot(1:step,[mstr-vstr;mstr+vstr],':k')
%errorbar(1:step,mstr,vstr)
xlabel('time','fontsize',23)
ylabel('collapse fraction','fontsize',23)
axis tight
a=axis;
a(1)=0;
a(4)=.5;
axis(a)
line([400,400],[a(3),a(4)],'color','k','linestyle','--')
box
set(0,'defaultaxesfontsize',23)
set(0,'defaulttextfontsize',23)
set(findobj(gcf,'Type','line'),'LineWidth',3)

% print('-dpng',['/users/sbi00/uliebal/Documents/yang/rostock/sysmo1_bacell/models/struct_stress/p1012/triangle_sim/data/1205_time-VS-collfract_+-stress50runs'])

%% testing the effect if both collapse and relaxation parameters are changed
set(0,'defaultaxesfontsize',23)
set(0,'defaulttextfontsize',23)
RandStream.setDefaultStream(RandStream('mt19937ar','seed',sum(100*clock)));

rnge = [0,1];
cntr = 15;
csmp = 2;
dstr = 1;
outp = lathypsam(rnge,cntr,csmp,dstr);
nsim = size(outp,1);
rcol = outp(:,2); % 0.001;outp(:,1)
rrlx = .9;
coop = outp(:,1); %outp(:,1);0
ssta = 200; % start statistics of mean collapse
step = 300;
nstr = 50;
msac = zeros(nstr,1);
mstr = zeros(nsim,1);
for i1=1:nsim
    ppar=[rcol(i1),rrlx,coop(i1)];
  for i2=1:nstr
    colm=trianglestressosome_1107(ppar,step);
    msac(i2)=mean(mean(colm(:,[ssta:step]))); % msac(i2,:)=mean(colm);
  end
  mstr(i1) = mean(msac);
%  vstr(i1,:) = std(msac); 
end
%avpt = mean(mstr,2); % average stresssome activity determined over position and simulation time

figure
scatter(coop,rcol,50,mstr,'filled')
xlabel('coop','fontsize',23) % collapse cooperation
ylabel('r_{col}','fontsize',23)
cb = colorbar('vert');
zlab = get(cb,'ylabel');
set(zlab,'String','collapse fract. of max 20','fontsize',23); 
box
% print('-dpng',['/users/sbi00/uliebal/Documents/yang/rostock/sysmo1_bacell/models/struct_stress/p1012/triangle_sim/data/1205_coop-VS-coll-VS-collfract_rrlx09'])
%% counting how many triangles are collapsed
seva = 1000; % statistics evaluations
step = 300; % number of simulation steps
ppar = [.001,.25]; % roughly comparable phosporylation magnitudes of partial collapse stimulation
coop = [.01,.5];
cuto = [0.25,0.6]; % frequency of a collapse for a triangle in one simulation
clear colm ceff
for i0=1:length(cuto)

for i1 = 1:seva
    colm = trianglestressosome_1107([ppar,coop(1)],step);
    msta = mean(colm,2);
    high = find(msta>cuto(i0));
    ceff(i1,1,i0) = length(high); % collapse efficiency
end
for i1 = 1:seva
    colm = trianglestressosome_1107([ppar,coop(2)],step);
    msta = mean(colm,2);
    high = find(msta>cuto(i0));
    ceff(i1,2,i0) = length(high); % collapse efficiency
end
end
cbini = unique(ceff(:,1,:)); % number of collapsed triangles isolated collapse
cbinc = unique(ceff(:,2,:)); % number of collapsed triangles cooperative collapse
binfi = hist(ceff(:,1,:),length(cbini))/seva; % bin filling, i.e. number of above cuto collapsed triangles
binfc = hist(ceff(:,2,:),length(cbinc))/seva; % bin filling, i.e. number of above cuto collapsed triangles

set(0,'defaultaxesfontsize',23)
set(0,'defaulttextfontsize',23)
figure; hold on
plot(cbini,binfi(:,2)*100,'^--','color',[.6,.6,.6])
plot(cbini,binfi(:,1)*100,'^-','color',[.6,.6,.6])
plot(cbinc,binfc(:,2)*100,'ks--')
plot(cbinc,binfc(:,1)*100,'ks-')
axis tight
%a=axis;
%a(4)=1;
%axis(a)
xlabel('number of triangles')
ylabel('Occurence in simulation (%)')
legend('f_{col}>0.6, -coop','f_{col}>0.25, -coop','f_{col}>0.6, +coop','f_{col}>0.25, +coop','location','best')
set(findobj(gcf,'Type','line'),'LineWidth',3)
box
% print('-dpng',['/users/sbi00/uliebal/Documents/yang/rostock/sysmo1_bacell/models/struct_stress/p1012/triangle_sim/data/1205_trianperc-VS-simocc-VS-collFract_+-coop'])