function [output] = bacell_0910_liebal_id280_BSU115_3IPTG_ind(varargin)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 0910_alldeg.txt
% Generated: 28-Oct-2009 18:15:19
% 
% [output] = bacell_0910_liebal_id280_BSU115_3IPTG_ind() => output = initial conditions in column vector
% [output] = bacell_0910_liebal_id280_BSU115_3IPTG_ind('states') => output = state names in cell-array
% [output] = bacell_0910_liebal_id280_BSU115_3IPTG_ind('algebraic') => output = algebraic variable names in cell-array
% [output] = bacell_0910_liebal_id280_BSU115_3IPTG_ind('parameters') => output = parameter names in cell-array
% [output] = bacell_0910_liebal_id280_BSU115_3IPTG_ind('parametervalues') => output = parameter values in column vector
% [output] = bacell_0910_liebal_id280_BSU115_3IPTG_ind(time,statevector) => output = time derivatives in column vector
% 
% State names and ordering:
% 
% statevector(1): sigb
% statevector(2): lacz
% statevector(3): regb
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global time
parameterValuesNew = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HANDLE VARIABLE INPUT ARGUMENTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin == 0,
	% Return initial conditions of the state variables (and possibly algebraic variables)
	output = [0, 0, 0];
	output = output(:);
	return
elseif nargin == 1,
	if strcmp(varargin{1},'states'),
		% Return state names in cell-array
		output = {'sigb', 'lacz', 'regb'};
	elseif strcmp(varargin{1},'algebraic'),
		% Return algebraic variable names in cell-array
		output = {};
	elseif strcmp(varargin{1},'parameters'),
		% Return parameter names in cell-array
		output = {'IPTG', 'kbs', 'kbd', 'kzs', 'kzd', 'kzr', 'krs', 'krd'};
	elseif strcmp(varargin{1},'parametervalues'),
		% Return parameter values in column vector
		output = [100, 100, 0.0164812, 9.03538e-07, 1.34615e-07, 0.00317772, 9.32517e-08, 1.08559e-09];
	else
		error('Wrong input arguments! Please read the help text to the ODE file.');
	end
	output = output(:);
	return
elseif nargin == 2,
	time = varargin{1};
	statevector = varargin{2};
elseif nargin == 3,
	time = varargin{1};
	statevector = varargin{2};
	parameterValuesNew = varargin{3};
	if length(parameterValuesNew) ~= 8,
		parameterValuesNew = [];
	end
elseif nargin == 4,
	time = varargin{1};
	statevector = varargin{2};
	parameterValuesNew = varargin{4};
else
	error('Wrong input arguments! Please read the help text to the ODE file.');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STATES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigb = statevector(1);
lacz = statevector(2);
regb = statevector(3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARAMETERS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isempty(parameterValuesNew),
	IPTG = 100;
	kbs = 100;
	kbd = 0.0164812;
	kzs = 9.03538e-07;
	kzd = 1.34615e-07;
	kzr = 0.00317772;
	krs = 9.32517e-08;
	krd = 1.08559e-09;
else
	IPTG = parameterValuesNew(1);
	kbs = parameterValuesNew(2);
	kbd = parameterValuesNew(3);
	kzs = parameterValuesNew(4);
	kzd = parameterValuesNew(5);
	kzr = parameterValuesNew(6);
	krs = parameterValuesNew(7);
	krd = parameterValuesNew(8);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DIFFERENTIAL EQUATIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigb_dot = IPTG*kbs-sigb*kbd;
lacz_dot = kzs*sigb-lacz*(kzd+kzr*regb);
regb_dot = krs*sigb-krd*regb;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% RETURN VALUES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STATE ODEs
output(1) = sigb_dot;
output(2) = lacz_dot;
output(3) = regb_dot;
% return a column vector 
output = output(:);
return


