function [output] = bacell_0910_liebal_BSA115_3IPTG_sbdeg(varargin)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 0910_deg.txt
% Generated: 16-Nov-2009 17:21:35
% 
% [output] = bacell_0910_liebal_BSA115_3IPTG_sbdeg() => output = initial conditions in column vector
% [output] = bacell_0910_liebal_BSA115_3IPTG_sbdeg('states') => output = state names in cell-array
% [output] = bacell_0910_liebal_BSA115_3IPTG_sbdeg('algebraic') => output = algebraic variable names in cell-array
% [output] = bacell_0910_liebal_BSA115_3IPTG_sbdeg('parameters') => output = parameter names in cell-array
% [output] = bacell_0910_liebal_BSA115_3IPTG_sbdeg('parametervalues') => output = parameter values in column vector
% [output] = bacell_0910_liebal_BSA115_3IPTG_sbdeg(time,statevector) => output = time derivatives in column vector
% 
% State names and ordering:
% 
% statevector(1): sigb
% statevector(2): lacz
% statevector(3): regb
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global time
parameterValuesNew = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HANDLE VARIABLE INPUT ARGUMENTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin == 0,
	% Return initial conditions of the state variables (and possibly algebraic variables)
	output = [0, 0, 0];
	output = output(:);
	return
elseif nargin == 1,
	if strcmp(varargin{1},'states'),
		% Return state names in cell-array
		output = {'sigb', 'lacz', 'regb'};
	elseif strcmp(varargin{1},'algebraic'),
		% Return algebraic variable names in cell-array
		output = {};
	elseif strcmp(varargin{1},'parameters'),
		% Return parameter names in cell-array
		output = {'IPTG', 'kbs', 'kbd', 'kzs', 'kzd', 'krs', 'krd', 'kbr'};
	elseif strcmp(varargin{1},'parametervalues'),
		% Return parameter values in column vector
		output = [100, 100, 5.77835e-09, 1.69124e-06, 0.0519618, 2.03085e-06, 1.24642e-13, 8.37104e-05];
	else
		error('Wrong input arguments! Please read the help text to the ODE file.');
	end
	output = output(:);
	return
elseif nargin == 2,
	time = varargin{1};
	statevector = varargin{2};
elseif nargin == 3,
	time = varargin{1};
	statevector = varargin{2};
	parameterValuesNew = varargin{3};
	if length(parameterValuesNew) ~= 8,
		parameterValuesNew = [];
	end
elseif nargin == 4,
	time = varargin{1};
	statevector = varargin{2};
	parameterValuesNew = varargin{4};
else
	error('Wrong input arguments! Please read the help text to the ODE file.');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STATES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigb = statevector(1);
lacz = statevector(2);
regb = statevector(3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARAMETERS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isempty(parameterValuesNew),
	IPTG = 100;
	kbs = 100;
	kbd = 5.77835e-09;
	kzs = 1.69124e-06;
	kzd = 0.0519618;
	krs = 2.03085e-06;
	krd = 1.24642e-13;
	kbr = 8.37104e-05;
else
	IPTG = parameterValuesNew(1);
	kbs = parameterValuesNew(2);
	kbd = parameterValuesNew(3);
	kzs = parameterValuesNew(4);
	kzd = parameterValuesNew(5);
	krs = parameterValuesNew(6);
	krd = parameterValuesNew(7);
	kbr = parameterValuesNew(8);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DIFFERENTIAL EQUATIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigb_dot = IPTG*kbs-sigb*(kbd+kbr*regb);
lacz_dot = kzs*sigb-kzd*lacz;
regb_dot = krs*sigb-krd*regb;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% RETURN VALUES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STATE ODEs
output(1) = sigb_dot;
output(2) = lacz_dot;
output(3) = regb_dot;
% return a column vector 
output = output(:);
return


