function [output] = bacell_0910_liebal_BSA115_3IPTG_tscrinh(varargin)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% 0910_syn.txt
% Generated: 16-Nov-2009 17:23:18
% 
% [output] = bacell_0910_liebal_BSA115_3IPTG_tscrinh() => output = initial conditions in column vector
% [output] = bacell_0910_liebal_BSA115_3IPTG_tscrinh('states') => output = state names in cell-array
% [output] = bacell_0910_liebal_BSA115_3IPTG_tscrinh('algebraic') => output = algebraic variable names in cell-array
% [output] = bacell_0910_liebal_BSA115_3IPTG_tscrinh('parameters') => output = parameter names in cell-array
% [output] = bacell_0910_liebal_BSA115_3IPTG_tscrinh('parametervalues') => output = parameter values in column vector
% [output] = bacell_0910_liebal_BSA115_3IPTG_tscrinh(time,statevector) => output = time derivatives in column vector
% 
% State names and ordering:
% 
% statevector(1): sigb
% statevector(2): lacz
% statevector(3): regb
% 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

global time
parameterValuesNew = [];

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% HANDLE VARIABLE INPUT ARGUMENTS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if nargin == 0,
	% Return initial conditions of the state variables (and possibly algebraic variables)
	output = [0, 0, 0];
	output = output(:);
	return
elseif nargin == 1,
	if strcmp(varargin{1},'states'),
		% Return state names in cell-array
		output = {'sigb', 'lacz', 'regb'};
	elseif strcmp(varargin{1},'algebraic'),
		% Return algebraic variable names in cell-array
		output = {};
	elseif strcmp(varargin{1},'parameters'),
		% Return parameter names in cell-array
		output = {'IPTG', 'kbs', 'kbd', 'kzs', 'kzd', 'krs', 'krd'};
	elseif strcmp(varargin{1},'parametervalues'),
		% Return parameter values in column vector
		output = [100, 100, 0.0439745, 0.000431305, 0.0408904, 0.763994, 9.00373];
	else
		error('Wrong input arguments! Please read the help text to the ODE file.');
	end
	output = output(:);
	return
elseif nargin == 2,
	time = varargin{1};
	statevector = varargin{2};
elseif nargin == 3,
	time = varargin{1};
	statevector = varargin{2};
	parameterValuesNew = varargin{3};
	if length(parameterValuesNew) ~= 7,
		parameterValuesNew = [];
	end
elseif nargin == 4,
	time = varargin{1};
	statevector = varargin{2};
	parameterValuesNew = varargin{4};
else
	error('Wrong input arguments! Please read the help text to the ODE file.');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STATES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigb = statevector(1);
lacz = statevector(2);
regb = statevector(3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PARAMETERS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if isempty(parameterValuesNew),
	IPTG = 100;
	kbs = 100;
	kbd = 0.0439745;
	kzs = 0.000431305;
	kzd = 0.0408904;
	krs = 0.763994;
	krd = 9.00373;
else
	IPTG = parameterValuesNew(1);
	kbs = parameterValuesNew(2);
	kbd = parameterValuesNew(3);
	kzs = parameterValuesNew(4);
	kzd = parameterValuesNew(5);
	krs = parameterValuesNew(6);
	krd = parameterValuesNew(7);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% DIFFERENTIAL EQUATIONS
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
sigb_dot = IPTG*kbs-kbd*sigb;
lacz_dot = kzs*sigb/(1+regb)-kzd*lacz;
regb_dot = sigb*krs/(1+regb)-krd*regb;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% RETURN VALUES
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% STATE ODEs
output(1) = sigb_dot;
output(2) = lacz_dot;
output(3) = regb_dot;
% return a column vector 
output = output(:);
return


